#ifndef GLOBAL__H
#define GLOBAL__H

#include <SDL/SDL.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#ifndef M_PI
#define M_PI 3.1415926535897932384626433832795
#endif

extern SDL_Surface *screen;

void setpalette(SDL_Surface *s);
void blitsurface(SDL_Surface *s);
void fillsurface(SDL_Surface *s, int color, bool blit=true);
inline void fillscreen(int color, bool blit=true)
{
  fillsurface(screen, color, blit);
}
int getpos();
int getrow();
void checkabort();

inline void SDL_UpdateRect(SDL_Surface *screen, SDL_Rect *r=0)
{
  if(r==0)
    SDL_UpdateRect(screen, 0, 0, screen->w, screen->h);
  else
    SDL_UpdateRect(screen, r->x, r->y, r->w, r->h);
}

inline int random(const int r)
{
  return static_cast<int>(static_cast<double>(rand())/RAND_MAX*r);
}

#endif
