#include "global.h"

static SDL_Surface *ship_bmp=0;
static SDL_Surface *introdiv_bmp=0;
static SDL_Surface *top00000_bmp=0;
static SDL_Surface *top00001_bmp=0;
static SDL_Surface *top00002_bmp=0;
static SDL_Surface *kimon_bmp=0;
static SDL_Surface *crw00000_bmp=0;
static SDL_Surface *crw00001_bmp=0;
static SDL_Surface *crw00002_bmp=0;
static SDL_Surface *crw00003_bmp=0;
static SDL_Surface *crw00004_bmp=0;
static SDL_Surface *crw00005_bmp=0;
static SDL_Surface *crw00006_bmp=0;
static SDL_Surface *crw00007_bmp=0;

static void cleanup()
{
  if(ship_bmp)
    SDL_FreeSurface(ship_bmp), ship_bmp=0;
  if(introdiv_bmp)
    SDL_FreeSurface(introdiv_bmp), introdiv_bmp=0;
  if(top00000_bmp)
    SDL_FreeSurface(top00000_bmp), top00000_bmp=0;
  if(top00001_bmp)
    SDL_FreeSurface(top00001_bmp), top00001_bmp=0;
  if(top00002_bmp)
    SDL_FreeSurface(top00002_bmp), top00002_bmp=0;
  if(kimon_bmp)
    SDL_FreeSurface(kimon_bmp), kimon_bmp=0;
  if(crw00000_bmp)
    SDL_FreeSurface(crw00000_bmp), crw00000_bmp=0;
  if(crw00001_bmp)
    SDL_FreeSurface(crw00001_bmp), crw00001_bmp=0;
  if(crw00002_bmp)
    SDL_FreeSurface(crw00002_bmp), crw00002_bmp=0;
  if(crw00003_bmp)
    SDL_FreeSurface(crw00003_bmp), crw00003_bmp=0;
  if(crw00004_bmp)
    SDL_FreeSurface(crw00004_bmp), crw00004_bmp=0;
  if(crw00005_bmp)
    SDL_FreeSurface(crw00005_bmp), crw00005_bmp=0;
  if(crw00006_bmp)
    SDL_FreeSurface(crw00006_bmp), crw00006_bmp=0;
  if(crw00007_bmp)
    SDL_FreeSurface(crw00007_bmp), crw00007_bmp=0;
}

int init_intro()
{
  atexit(cleanup);

  if(!(ship_bmp=SDL_LoadBMP("ship.bmp")))
    return -1;
  SDL_SetColorKey(ship_bmp, SDL_SRCCOLORKEY, 255);
  if(!(introdiv_bmp=SDL_LoadBMP("introdiv.bmp")))
    return -1;
  if(!(top00000_bmp=SDL_LoadBMP("top00000.bmp")))
    return -1;
  if(!(top00001_bmp=SDL_LoadBMP("top00001.bmp")))
    return -1;
  if(!(top00002_bmp=SDL_LoadBMP("top00002.bmp")))
    return -1;
  if(!(kimon_bmp=SDL_LoadBMP("kimon.bmp")))
    return -1;
  if(!(crw00000_bmp=SDL_LoadBMP("crw00000.bmp")))
    return -1;
  if(!(crw00001_bmp=SDL_LoadBMP("crw00001.bmp")))
    return -1;
  if(!(crw00002_bmp=SDL_LoadBMP("crw00002.bmp")))
    return -1;
  if(!(crw00003_bmp=SDL_LoadBMP("crw00003.bmp")))
    return -1;
  if(!(crw00004_bmp=SDL_LoadBMP("crw00004.bmp")))
    return -1;
  if(!(crw00005_bmp=SDL_LoadBMP("crw00005.bmp")))
    return -1;
  if(!(crw00006_bmp=SDL_LoadBMP("crw00006.bmp")))
    return -1;
  if(!(crw00007_bmp=SDL_LoadBMP("crw00007.bmp")))
    return -1;
  return 0;
}

void pal_fadein(SDL_Surface *s)
{
  int i;
  Uint32 starttime;
  double time;
  SDL_Color newpal[256];
  SDL_Color *pal=s->format->palette->colors;

  starttime=SDL_GetTicks();
  do {
    time=static_cast<double>(SDL_GetTicks()-starttime)*.001;
    for(i=0; i<256; i++)
    {
      newpal[i].r=static_cast<unsigned char>(time*pal[i].r);
      newpal[i].g=static_cast<unsigned char>(time*pal[i].g);
      newpal[i].b=static_cast<unsigned char>(time*pal[i].b);
    }
    SDL_SetColors(screen, newpal, 0, 256);
    checkabort();
  } while(time<1.0);
  SDL_SetColors(screen, pal, 0, 256);
}

void pal_fadewhite(SDL_Surface *s)
{
  int i;
  Uint32 starttime;
  double time;
  SDL_Color newpal[256], diffpal[256];
  SDL_Color *pal=s->format->palette->colors;

  for(i=0; i<256; i++)
  {
    diffpal[i].r=255-pal[i].r;
    diffpal[i].g=255-pal[i].g;
    diffpal[i].b=255-pal[i].b;
  }

  starttime=SDL_GetTicks();
  do {
    time=static_cast<double>(SDL_GetTicks()-starttime)*.001;
    for(i=0; i<256; i++)
    {
      newpal[i].r=static_cast<unsigned char>((time*diffpal[i].r+pal[i].r)*.95);
      newpal[i].g=static_cast<unsigned char>((time*diffpal[i].g+pal[i].g)*.95);
      newpal[i].b=static_cast<unsigned char>((time*diffpal[i].b+pal[i].b)*.95);
    }
    SDL_SetColors(screen, newpal, 0, 256);
    checkabort();
  } while(time<1.0);
}

void pal_fadeblack(SDL_Surface *s)
{
  int i;
  Uint32 starttime;
  double time;
  SDL_Color newpal[256], pal[256];
  memcpy(pal, s->format->palette->colors, sizeof(pal));

  starttime=SDL_GetTicks();
  do {
    time=static_cast<double>(SDL_GetTicks()-starttime)*.001;
    for(i=0; i<256; i++)
    {
      int c=static_cast<int>(pal[i].r-time*255.0);
      newpal[i].r=(c<0)?0:c;
      c=static_cast<int>(pal[i].g-time*255.0);
      newpal[i].g=(c<0)?0:c;
      c=static_cast<int>(pal[i].b-time*255.0);
      newpal[i].b=(c<0)?0:c;
    }
    SDL_SetColors(screen, newpal, 0, 256);
    checkabort();
  } while(time<1.0);
}


void moveship(double speed, int row)
{
  int i;
  Uint32 starttime;
  double time;

  starttime=SDL_GetTicks();
  do {
    time=static_cast<double>(SDL_GetTicks()-starttime)*.001;
    i=270-static_cast<int>(time*speed*320.0);

    SDL_Rect dst={i, 150, ship_bmp->w, ship_bmp->h};

    fillscreen(31, false); // clear screen
    SDL_BlitSurface(ship_bmp, NULL, screen, &dst);
    SDL_UpdateRect(screen);
    checkabort();
  } while(getrow()<row && i>=0);
}

void intro()
{
  int i;
  Uint32 starttime;
  double time;

  SDL_Color blackpal[256];
  memset(blackpal, 0, sizeof(blackpal));

  if(getpos()<1)
  {
    // 1. Teil, die drei Linien
    setpalette(introdiv_bmp);
    fillscreen(1); // fill with black

    //1. Line
    starttime=SDL_GetTicks();
    do {
      time=static_cast<double>(SDL_GetTicks()-starttime)*.001;
      i=static_cast<int>(time*4.0*320.0);

      SDL_Rect src={0, 0,  320-i, 1};
      SDL_Rect dst={i, 99, 320-i, 1};

      SDL_BlitSurface(introdiv_bmp, &src, screen, &dst);
      SDL_UpdateRect(screen, &dst);
      checkabort();
    } while(time<0.25 && getpos()<1);

    starttime=SDL_GetTicks();
    do {
      time=static_cast<double>(SDL_GetTicks()-starttime)*.001;
      i=static_cast<int>(time*4.0*320.0);

      SDL_Rect src={319-i, 0, i, 1};
      SDL_Rect dst={0, 99,    i, 1};

      SDL_BlitSurface(introdiv_bmp, &src, screen, &dst);
      SDL_UpdateRect(screen, &dst);
      checkabort();
    } while(time<0.25 && getpos()<1);
  }

  //2. Linie
  if(getpos()<2)
  {
    starttime=SDL_GetTicks();
    do {
      time=static_cast<double>(SDL_GetTicks()-starttime)*.001;
      i=static_cast<int>(time*4.0*320.0);

      SDL_Rect src={319-i, 1, i, 1};
      SDL_Rect dst={0,    99, i, 1};

      SDL_BlitSurface(introdiv_bmp, &src, screen, &dst);
      SDL_UpdateRect(screen, &dst);
      checkabort();
    } while(time<0.25 && getpos()<2);

    starttime=SDL_GetTicks();
    do {
      time=static_cast<double>(SDL_GetTicks()-starttime)*.001;
      i=static_cast<int>(time*4.0*320.0);

      SDL_Rect src={0, 1,  319-i, 1};
      SDL_Rect dst={i, 99, 319-i, 1};

      SDL_BlitSurface(introdiv_bmp, &src, screen, &dst);
      SDL_UpdateRect(screen, &dst);
      checkabort();
    } while(time<0.25 && getpos()<2);
  }

  //3. Line
  if(getpos()<3)
  {
    starttime=SDL_GetTicks();
    do {
      time=static_cast<double>(SDL_GetTicks()-starttime)*.001;
      i=static_cast<int>(time*4.0*320.0);

      SDL_Rect src={0, 2, 320-i, 1};
      SDL_Rect dst={i,99, 320-i, 1};

      SDL_BlitSurface(introdiv_bmp, &src, screen, &dst);
      SDL_UpdateRect(screen, &dst);
      checkabort();
    } while(time<0.25 && getpos()<3);

    starttime=SDL_GetTicks();
    do {
      time=static_cast<double>(SDL_GetTicks()-starttime)*.001;
      i=static_cast<int>(time*4.0*320.0);

      SDL_Rect src={319-i, 2, i, 1};
      SDL_Rect dst={0,    99, i, 1};

      SDL_BlitSurface(introdiv_bmp, &src, screen, &dst);
      SDL_UpdateRect(screen, &dst);
      checkabort();
    } while(time<0.25 && getpos()<3);
  }

  // Raumschiff
  if(getpos()<4)
  {
    setpalette(ship_bmp);
    moveship(.1, 32);
    moveship(.1, 58);
    moveship(.6, 63);
    while(getpos()<4) checkabort();
  }

  //3. ToPCReW presents
  if(getpos()<8)
  {
    // display first picture
    blitsurface(top00000_bmp);
    pal_fadein(top00000_bmp);
    while(getpos()<5) checkabort();

    // overdraw from left to right with second picture
    starttime=SDL_GetTicks();
    int lasti=0;
    do {
      time=static_cast<double>(SDL_GetTicks()-starttime)*.001;
      i=static_cast<int>(time*320.0*0.5);
      if(i!=lasti)
      {
        SDL_Rect src={lasti, 0, i, 200};
        SDL_Rect dst={lasti, 0, i, 200};

        SDL_BlitSurface(top00001_bmp, &src, screen, &dst);
        SDL_UpdateRect(screen, &dst);

        lasti=i;
      }
      checkabort();
    } while(time<2.0);
    while(getpos()<6) checkabort();

    // fade to white, fade to black
    pal_fadewhite(top00001_bmp);
    pal_fadeblack(screen);
    while(getpos()<7) checkabort();

    // third picture
    blitsurface(top00002_bmp);
    pal_fadein(top00002_bmp);
    while(getpos()<8) checkabort();
  }

  blitsurface(kimon_bmp);
  while(getpos()<9) checkabort();

  blitsurface(crw00000_bmp);
  while(getpos()<10) checkabort();
  blitsurface(crw00001_bmp);
  while(getpos()<11) checkabort();
  blitsurface(crw00002_bmp);
  while(getpos()<12) checkabort();
  blitsurface(crw00003_bmp);
  while(getpos()<13) checkabort();
  blitsurface(crw00004_bmp);
  while(getpos()<14) checkabort();
  blitsurface(crw00006_bmp);
  while(getpos()<15) checkabort();
  blitsurface(crw00007_bmp);
  while(getpos()<16) checkabort();
  blitsurface(crw00005_bmp);
  while(getpos()<17) checkabort();

  fillscreen(15);
  while(getpos()<18) checkabort();
}
