#include "global.h"
#include "effects.h"

#include <complex>

void lissajous(double x,double y, unsigned char col)
{
  static double ox=0, oy=0;
  SDL_LockSurface(screen);
  memset(screen->pixels, 0, screen->w*screen->h);
  for(int p=0;p<360;p++)
  {
    const double x1=cos(y*(p))*80.0+80.0 + sin(ox)*80.0+80.0;
    const double y1=sin(x*(p))*50.0+50.0 + sin(oy)*40.0+50.0;
    reinterpret_cast<unsigned char*>(screen->pixels)[320*static_cast<int>(y1)+static_cast<int>(x1)]=col;
  }
  ox+=.02134;
  oy+=.0123;
  SDL_UnlockSurface(screen);
  SDL_UpdateRect(screen);
}

void lisa(int modbegin)
{
  int i=0;

  SDL_Color pal[256];
  pal_make(pal,   0,  64, 255, 0, 0, 0, 255, 0);
  pal_make(pal,  65, 128, 0, 255, 0, 0, 255, 255);
  pal_make(pal, 129, 192, 0, 255, 255, 255, 255, 0);
  pal_make(pal, 193, 255, 255, 255, 0, 255, 0, 0);
  SDL_SetColors(screen, pal, 0, 256);

  const double x1=-2, x2=2;
  const double y1=-1.5, y2=1.5;
  const double xd=x2-x1, yd=y2-y1;

  Uint32 starttime;
  double time;

  starttime=SDL_GetTicks();
  do {
    time=static_cast<double>(SDL_GetTicks()-starttime)*.001;

    SDL_LockSurface(screen);
    unsigned char *julybuf=reinterpret_cast<unsigned char*>(screen->pixels);
    const std::complex<double> c(sin(time)+cos(time*3.0)*.25, cos(time)+cos(time*4.0)*.25);
    for(int y=0; y<200; y++)
      {
	const double Y=y1+y/200.0*yd;
	for(int x=0; x<320; x++)
	  {
	    const double X=x1+x/320.0*xd;
	    std::complex<double> z(X,Y);
	    int depth=32;
	    while(depth && z.real()*z.imag()<4.0)
	      {
		z*=z;
		z+=c;
		depth--;
	      }
	    *julybuf++=depth*8;
	  }
	checkabort();
      }
    SDL_UnlockSurface(screen);
    SDL_UpdateRect(screen);
  }
  while(getpos()<modbegin+4);

  // make first color black
  pal[0].r=pal[0].g=pal[0].b=0;
  SDL_SetColors(screen, pal, 0, 1);

  double tno=2134.235, w;
  char delta=1;
  int c=1;
  while(getpos()<(modbegin+6))
  {
    checkabort();

    w=tno;
    w*=320;
    tno=sin(fmod((double)i/50.0,M_PI))*160.0+240.0;
    w+=tno;
    lissajous(0.1+(double)i/1000000.0, (double)i/10000.0, c);

    tno=sin(fmod((double)i/50.0,M_PI))*100.0;
    if(i==4000)
      delta=-1;
    if(!i)
      delta=1;
    i+=delta;

    if(++c>=256)
      c=1;
  }
}
