#include "global.h"
#include "effects.h"
#include <stdlib.h>

static unsigned char *ani_dat=0;
static SDL_Color ani_pal[256];
static SDL_Surface *text[30];

void cleanup()
{
  if(ani_dat)
    delete [] ani_dat, ani_dat=0;
  int i;
  for(i=0; i<30; i++)
    if(text[i])
      SDL_FreeSurface(text[i]), text[i]=0;
}

int init_playani()
{
  atexit(cleanup);

  int i;

  if(!(ani_dat=new unsigned char[1344000]))
    return -1;

  FILE *f=fopen("ani.dat", "rb");
  if(f==0)
    return -1;
  if(fread(ani_dat, 1344000, 1, f)!=1)
  {
    fclose(f);
    return -1;
  }
  fclose(f);

  unsigned char pal[256*3];
  f=fopen("ani.pal", "rb");
  if(f==0)
    return -1;
  if(fread(pal, 256*3, 1, f)!=1)
  {
    fclose(f);
    return -1;
  }
  fclose(f);
  for(i=0; i<256; i++)
  {
    ani_pal[i].r=pal[3*i];
    ani_pal[i].g=pal[3*i+1];
    ani_pal[i].b=pal[3*i+2];
  }

  for(i=0; i<30; i++)
    text[i]=0;
  char *t[] = {
    "the greets go to:",
    "neutron          ",
    "       sanction  ",
    "ntr.psychopathics",
    "      post mortem",
    "   xography      ",
    "           eda   ",
    "              fbk",
    "vacuum           ",
    "      n-factor   ",
    "    fatal justice",
    "audiokraft       ",
    "   black maiden  ",
    "who s that bert !",
    "   cubic team    ",
    "tsc/nbc          ",
    "   cosmic orgasm ",
    "suicide group    ",
    "          pois0n ",
    "  fantasy arts   ",
    " skyline magazin ",
    "deep!            ",
    "     elyssis     ",
    "future crew      ",
    "           emf   ",
    "    witan        ",
    "the coexistence  ",
    "purge public nmi ",
    " purple motion   ",
    "   windows 95 !  ",
  };
  for(i=0; i<30; i++)
    if(!(text[i]=makescroller(t[i])))
      return -1;

  return 0;
}

void playani(int modstart)
{
  SDL_SetColors(screen, ani_pal, 0, 256);
  int z=0;
  while(getpos()<modstart+1)
  {
    checkabort();
    SDL_LockSurface(screen);
    memcpy(screen->pixels, &ani_dat[z*64000], 64000);
    SDL_UnlockSurface(screen);
    SDL_UpdateRect(screen);
    (++z)%=21;
    SDL_Delay(80);
  }

// ab hier die greets
  int zz=0;
  int flag=1;
  SDL_Color *font_pal=font_bmp->format->palette->colors;
  while(getpos()<modstart+8)
  {
    checkabort();
    const int row=getrow();
    if((row>8 && row<16) || (row>24 && row<32) || (row>40 && row<48) || (row>56 && row<64))
    {
      if(flag==0)
      {
        ani_pal[0].r=(z%5)*100;
        ani_pal[0].g=(z%5)*80;
        ani_pal[0].b=(z%5)*150;
        SDL_SetColors(screen, ani_pal, 0, 256);
        flag=1;
      }
      SDL_LockSurface(screen);
      memcpy(screen->pixels, &ani_dat[z*64000], 64000);
      SDL_UnlockSurface(screen);
      SDL_UpdateRect(screen);
      (++z)%=21;
      SDL_Delay(80);
    }
    else
      if(flag)
      {
        fillsurface(screen, 0, false);
        font_pal[0].r=(z%5)*100;
        font_pal[0].g=(z%5)*80;
        font_pal[0].b=(z%5)*150;
        SDL_SetColors(screen, font_pal, 0, 256);

        SDL_Rect dst={0, (rand()%9)*20, 18*16, 36};
        SDL_BlitSurface(text[zz], NULL, screen, &dst);
        SDL_UpdateRect(screen);

        zz++;
        flag=0;
      }

  }

  // reset font palette
  font_pal[0].r=0;
  font_pal[0].g=0;
  font_pal[0].b=0;

  fillscreen(0);
  while(getpos()<modstart+9) checkabort();
}
